/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.68 by edhill, Tue Jun 7 22:21:47 2005 UTC revision 1.127 by jmc, Thu Jun 4 23:40:53 2009 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14      echo "  (-mpi)                   use MPI input files"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
15        echo "  (-mpi)                   compile and run using MPI"
16      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"      echo "  (-ieee|-noieee)          if possible, use IEEE compiler flags"
17      echo "                             (DEF=\"-ieee\")"      echo "                             (DEF=\"-ieee\")"
18      echo "  (-optfile=|-of=)STRING   list of optfiles to use"      echo "  (-gsl)                   compile with \"-gsl\" flag"
19        echo "  (-of=|-optfile=)STRING   list of optfiles to use"
20      echo "  (-a|-addr) STRING        list of email recipients"      echo "  (-a|-addr) STRING        list of email recipients"
21      echo "                             (DEF=\"edhill@mitgcm.org\")"      echo "                             (DEF=\"\" no email is sent)"
22      echo "  (-t|-tdir) STRING        list of test dirs to use"      echo "  (-mpd|-mpackdir) DIR     location of the mpack utility"
23      echo "                             (DEF=\"\" which builds all)"      echo "                             (DEF=\"../tools/mpack-1.6\")"
24        echo "  (-t|-tdir) STRING        list of group and/or exp. dirs to test"
25        echo "                             (recognized groups: basic, tutorials)"
26        echo "                             (DEF=\"\" which test all)"
27        echo "  (-skd|-skipdir) STRING   list of exp. dirs to skip"
28        echo "                             (DEF=\"\" which test all)"
29      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"      echo "  (-b|-bash) STRING        preferred location of a \"bash\" or"
30      echo "                             Bourne-compatible \"sh\" shell"      echo "                             Bourne-compatible \"sh\" shell"
31      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
32      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-adm|-ad)               perform an adjoint run"
33        echo "  (-oad)                   perform an OpenAD adjoint run"
34      echo "  (-command) STRING        command to run"      echo "  (-command) STRING        command to run"
35      echo "                             (DEF=\"make output.txt\")"      echo "                             (DEF=\"make output.txt\")"
36      echo "  (-m|-make) STRING        command to use for \"make\""      echo "  (-m|-make) STRING        command to use for \"make\""
37      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
38      echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"      echo "  (-odir) STRING           used to build output directory name"
39        echo "                             (DEF=\"hostname\")"
40        echo "  (-ptr|-ptracers) STRING  specify which ptracers to test"
41      echo "                             (DEF=\"1 2 3 4 5\")"      echo "                             (DEF=\"1 2 3 4 5\")"
42        echo "  (-match) NUMBER          Matching Criteria (number of digits)"
43        echo "                             (DEF=\"12\")"
44      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
45      echo "  (-clean)                 *ONLY* run \"make CLEAN\""      echo "  (-clean)                 *ONLY* run \"make CLEAN\""
46      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
# Line 36  usage() Line 48  usage()
48      echo "  (-noclean|-nc)           skip the \"make clean\" stage"      echo "  (-noclean|-nc)           skip the \"make clean\" stage"
49      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"      echo "  (-nodepend|-nd)          skip the \"make depend\" stage"
50      echo "  (-deldir|-dd)            on success, delete the output directory"      echo "  (-deldir|-dd)            on success, delete the output directory"
51        echo "  (-ts)                    provide timing information per timestep"
52        echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
53        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
54      echo      echo
55      echo "and where STRING can be a whitespace-delimited list"      echo "and where STRING can be a whitespace-delimited list"
56      echo "such as:"      echo "such as:"
# Line 53  usage() Line 68  usage()
68  build_mpack()  build_mpack()
69  {  {
70      printf "building the mpack utility...  "      printf "building the mpack utility...  "
71      if test ! -x "$MPACKDIR/mpack" ; then      MPACK="$MPACKDIR/mpack"
72        if test ! -x $MPACK ; then
73          if test ! -d $MPACKDIR ; then          if test ! -d $MPACKDIR ; then
74              echo              echo
75              echo "Error: can't find \"$MPACKDIR\""              echo "Error: can't find \"$MPACKDIR\""
# Line 62  build_mpack() Line 78  build_mpack()
78              echo              echo
79              HAVE_MPACK=f              HAVE_MPACK=f
80          fi          fi
         printf "building mpack...  "  
81          if test "x$CC" = x ; then          if test "x$CC" = x ; then
82              export CC=cc              export CC=cc
83          fi          fi
84            printf "building mpack (using CC=$CC)...  "
85          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1          ( cd $MPACKDIR && ./configure && $MAKE ) > tr_build_mpack.out 2>&1
86          RETVAL=$?          RETVAL=$?
87          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
# Line 76  build_mpack() Line 92  build_mpack()
92          else          else
93              rm -f tr_build_mpack.out              rm -f tr_build_mpack.out
94              HAVE_MPACK=t              HAVE_MPACK=t
95                echo "done"
96          fi          fi
97      else      else
98          HAVE_MPACK=t          HAVE_MPACK=t
99            echo "already exist"
100      fi      fi
     echo "OK"  
101  }  }
102    
103  testoutput_for_prop()  testoutput_var()
104  {  {
105      # testoutput_for_prop dir s1 label subdir extension      # testoutput_var dir s1 label subdir reference_output
106      #      #
107      #  compares files in $dir/$subdir/output.txt and $dir/results/output.txt      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
108      #  using search strings s1 and text label      #     with same output from reference file $dir/results/$reference_output
109        #  using search strings s1 and text label
110    
111      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
112          echo testoutput_for_prop: grep "$2" $1/$4/output.txt 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
113      fi      fi
114      if [ -r $1/$4/output.txt ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
115          grep "$2" $1/$4/output.txt | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt
116          lncntA=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l tmp1.txt | awk '{print $1}' `
117          if [ $lncntA -lt 3 ]; then          if [ $lncntA -lt 2 ]; then
118              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
119                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
120              fi              fi
121              return 99              return 99
122          fi          fi
123      else      else
124          echo testoutput_for_prop: output.txt from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
125          return 99          return 99
126      fi      fi
127      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
128          echo testoutput_for_prop: grep "$2" $1/results/output.txt$5 1>&2          echo testoutput_var: grep "$2" $1/results/$5 1>&2
129      fi      fi
130      grep "$2" $1/results/output.txt$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt
131      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l tmp2.txt | awk '{print $1}' `
132      if [ $lncntB -lt 3 ]; then      if [ $lncntB -lt 2 ]; then
133          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
134              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
135          fi          fi
# Line 123  testoutput_for_prop() Line 141  testoutput_for_prop()
141          fi          fi
142          return 99          return 99
143      fi      fi
144        has_nan=`cat tmp1.txt | grep -i nan | wc -l`
145        if [ $has_nan -gt 0  ] ; then
146            echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
147            return 99
148        fi
149        has_inf=`cat tmp1.txt | grep -i inf | wc -l`
150        if [ $has_inf -gt 0  ] ; then
151            echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
152            return 99
153        fi
154      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
155          echo testoutput_for_prop: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2
156      fi      fi
157      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt
158      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
159          echo testoutput_for_prop: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
160      fi      fi
161      if [ $verbose -gt 1 ]; then      if [ $verbose -gt 1 ]; then
162          cat tmp3.txt 1>&2          cat tmp3.txt 1>&2
# Line 136  testoutput_for_prop() Line 164  testoutput_for_prop()
164      echo "-1" >> tmp3.txt      echo "-1" >> tmp3.txt
165      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
166      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt      cat tmp3.txt | sed -e 's|:||g' > tmp4.txt
167      digits_of_similarity=`./tmp_cmpnum < tmp4.txt`      digits_of_similarity=`./tr_cmpnum < tmp4.txt`
168      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
169          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
170              echo testoutput_for_prop: No comparison was available for \"$2\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
171          fi          fi
172          digits_of_similarity=99          digits_of_similarity=99
173      else      else
174          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
175              echo There were $digits_of_similarity decimal places of similarity for \"$2\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
176          fi          fi
177      fi      fi
178      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt
# Line 152  testoutput_for_prop() Line 180  testoutput_for_prop()
180      return $digits_of_similarity      return $digits_of_similarity
181  }  }
182    
183  dashnum()  testoutput_run()
 {  
     # dashnum n1 n2 n3 ...  
     #  
     #  print numbers using %3i format or "--" if number = 99  
   
     for num in $@ ; do  
         if [ $num = 99 ]; then  
             printf ' --'  
         else  
             printf '%3i' $num  
         fi  
     done  
 }  
   
 testoutput_ad()  
 {  
     grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $5}' > t05.txt  
     grep $3 $1/$2/output.txt_adm | awk '{print NR " " $5}' > t15.txt  
     grep $3 $1/results_ad/output.txt_adm | awk '{print NR " " $6}' > t06.txt  
     grep $3 $1/$2/output.txt_adm | awk '{print NR " " $6}' > t16.txt  
     join t05.txt t15.txt > t5.txt  
     join t06.txt t16.txt > t6.txt  
     echo "-1" >> t5.txt  
     echo "-1" >> t6.txt  
     digits_5=`./tmp_cmpnum < t5.txt`  
     digits_6=`./tmp_cmpnum < t6.txt`  
     dashnum $digits_5 $digits_6  
     rm -f t[01][56].txt t[56].txt  
 }  
   
 check_for_add_mon_output()  
 {  
     # Check for additional types of monitor output  
     if test "x$1" = x ; then  
         return  
     fi  
   
     for ii in $PTRACERS_NUM ; do  
         eval "HAVE_PTR0"$ii"=f"  
     done  
   
     ptr_add="trcstat_ptracerXX_min trcstat_ptracerXX_max"  
     ptr_add="$ptr_add trcstat_ptracerXX_mean trcstat_ptracerXX_sd"  
     for ii in $PTRACERS_NUM ; do  
         for jj in $ptr_add ; do  
             name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`  
             tst=`grep $name $1 | wc -l | awk '{print $1}'`  
             if test ! "x$tst" = x0 ; then  
                 eval "HAVE_PTR0"$ii"=t"  
             fi  
         done  
         #  eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"'  
     done  
 }  
   
 testoutput()  
184  {  {
185      # testoutput directory subdir extension      # testoutput_run directory subdir reference_output
186      #      #
187      #  test output in "directory"      #  test output from 1 run in "directory"
188      if test "x$ADM" = x ; then  # --> same processing for adjoint & forward test
189          if [ $debug -gt 0 ]; then          # default list of output variables to be checked:
190              echo testoutput: testoutput_for_prop $1 cg2d_init_res 1>&2          #  1rst : main variable used to decide if it pass or FAIL
191          fi          #  others : number of matching digits to be printed in summary.txt
192          testoutput_for_prop $1 "cg2d_init_res" "cg2d init. residual" $2 $3; cg2dres=$?          listChk=$DEF_CHECK_LIST
193          if [ $debug -gt 0 ]; then          #  load experiment-specific list from file "tr_checklist" (if it exist)
194              echo testoutput: cg2dres=$cg2dres 1>&2          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
195          fi          sVar=`echo $listChk | awk '{print $1}'`
196          testoutput_for_prop $1 "dynstat_theta_min" "theta minimum" $2 $3; tmin=$?          # remove 1rst var and expand the list: + => min max mean s.d
197          testoutput_for_prop $1 "dynstat_theta_max" "theta maximum" $2 $3; tmax=$?          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
198          testoutput_for_prop $1 "dynstat_theta_mean" "theta mean" $2 $3; tmean=$?                                 | sed 's/+//g' | sed "s/^$sVar//"`
199          testoutput_for_prop $1 "dynstat_theta_sd" "theta s.d." $2 $3; tsd=$?          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
200          testoutput_for_prop $1 "dynstat_salt_min" "salt minimum" $2 $3; smin=$?          # check for ptracer output in reference_output file :
201          testoutput_for_prop $1 "dynstat_salt_max" "salt maximum" $2 $3; smax=$?          outpref=$1/results/$3
202          testoutput_for_prop $1 "dynstat_salt_mean" "salt mean" $2 $3; smean=$?          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
203          testoutput_for_prop $1 "dynstat_salt_sd" "salt s.d." $2 $3; ssd=$?          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
         testoutput_for_prop $1 "dynstat_uvel_min" "U minimum" $2 $3; umin=$?  
         testoutput_for_prop $1 "dynstat_uvel_max" "U maximum" $2 $3; umax=$?  
         testoutput_for_prop $1 "dynstat_uvel_mean" "U mean" $2 $3; umean=$?  
         testoutput_for_prop $1 "dynstat_uvel_sd" "U s.d." $2 $3; usd=$?  
         testoutput_for_prop $1 "dynstat_vvel_min" "V minimum" $2 $3; vmin=$?  
         testoutput_for_prop $1 "dynstat_vvel_max" "V maximum" $2 $3; vmax=$?  
         testoutput_for_prop $1 "dynstat_vvel_mean" "V mean" $2 $3; vmean=$?  
         testoutput_for_prop $1 "dynstat_vvel_sd" "V s.d." $2 $3; vsd=$?  
   
         #  This is for PTRACERS  
204          for ii in $PTRACERS_NUM ; do          for ii in $PTRACERS_NUM ; do
205              eval `echo "p0"$ii"_min=99"`              ptrfound=0
206              eval `echo "p0"$ii"_max=99"`              for jj in $ptr_mon ; do
207              eval `echo "p0"$ii"_mean=99"`                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
208              eval `echo "p0"$ii"_sd=99"`                  tst=`grep $name $outpref | wc -l | awk '{print $1}'`
209              tst=`eval 'echo "$HAVE_PTR0'$ii'"'`                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
210              #echo 'tst = '$tst              done
211              if test "x$tst" = xt ; then              if test $ptrfound = '1' ; then
212                  a="trcstat_ptracer0"                  eval "HAVE_PTR0"$ii"=t"
213                  testoutput_for_prop $1 "$a"$ii"_min"  "p0"$ii"_min"  $2 $3              else
214                  RETVAL=$? ; eval `echo "p0"$ii"_min="$RETVAL`                  eval "HAVE_PTR0"$ii"=f"
215                  testoutput_for_prop $1 "$a"$ii"_max"  "p0"$ii"_max"  $2 $3                if test "x$ADM" = x -a "x$OADM" = x; then
216                  RETVAL=$? ; eval `echo "p0"$ii"_max="$RETVAL`                # remove this ptr from the list of output variable to check
217                  testoutput_for_prop $1 "$a"$ii"_mean" "p0"$ii"_mean" $2 $3                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
218                  RETVAL=$? ; eval `echo "p0"$ii"_mean="$RETVAL`                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
219                  testoutput_for_prop $1 "$a"$ii"_sd"   "p0"$ii"_sd"   $2 $3                fi
                 RETVAL=$? ; eval `echo "p0"$ii"_sd="$RETVAL`  
220              fi              fi
221            #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
222          done          done
223            tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
224          allargs="$cg2dres $tmin $tmax $tmean $tsd $smin $smax $smean $ssd"          if test $tst != 1 ; then
225          allargs="$allargs $umin $umax $umean $usd $vmin $vmax $vmean $vsd"            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
226          allargs="$allargs $p01_min $p01_max $p01_mean $p01_sd"                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
227          allargs="$allargs $p02_min $p02_max $p02_mean $p02_sd"            echo "==> WARNING: in checked list:" $listVar 1>&2
228          allargs="$allargs $p03_min $p03_max $p03_mean $p03_sd"          #- put it back once:
229          allargs="$allargs $p04_min $p04_max $p04_mean $p04_sd"            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
230          allargs="$allargs $p05_min $p05_max $p05_mean $p05_sd"          fi
231            if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
232          eval "dashnum $allargs"          echo "listVar='$listVar'" > $CDIR"/summary.txt"
233            allargs=""
234      else          for xx in $listVar
235          testoutput_ad $1 $2 "precision_grdchk_result"          do
236      fi            case $xx in
237               'PS')  if [ $debug -gt 0 ]
238                      then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
239                      testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?
240                      if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
241              'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;
242              'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;
243               'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;
244               'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;
245               'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;
246               'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;
247               'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;
248               'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;
249               'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;
250               'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;
251               'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;
252               'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;
253               'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;
254               'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;
255               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;
256               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;
257               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;
258               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;
259            'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
260               testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;
261            'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
262               testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;
263            'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
264               testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;
265            'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
266               testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;
267             'Qntmn') testoutput_var $1 "extforcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;
268             'Qntmx') testoutput_var $1 "extforcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;
269             'Qntav') testoutput_var $1 "extforcing_qnet_mean" "Qnet mean"    $2 $3; yy=$? ;;
270             'Qntsd') testoutput_var $1 "extforcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;
271             'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;
272             'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;
273             'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;
274             'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;
275             'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;
276             'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;
277             'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;
278             'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;
279            'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;
280            'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;
281            'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;
282            'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;
283            'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;
284            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;
285                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
286              esac
287              if test $xx = $sVar
288              then allargs="$allargs > $yy <"
289              else allargs="$allargs $yy"
290              fi
291            done
292    
293            nbVar=`echo $listVar | awk '{print NF}'`
294            if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
295            #-- fill line (up to standard length) with dot:
296              adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
297              echo $allargs $adNul
298            else
299              echo $allargs
300            fi
301    # <-- same processing for adjoint & forward test
302  }  }
303    
304  genmakemodel()  genmakemodel()
# Line 288  genmakemodel() Line 315  genmakemodel()
315          (          (
316              cd $1;              cd $1;
317              command="$GENMAKE2  -ds -m $MAKE"              command="$GENMAKE2  -ds -m $MAKE"
318              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
                 command="$command --mods=../code"  
             else  
319                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
320                  command="$command -adof=../../../tools/adjoint_options/adjoint_staf"              elif test "x$OADM" = xt ; then
321                    command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"
322                else
323                    command="$command -mods=../code"
324              fi              fi
325              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
326                  command="$command --optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
327              fi              fi
328              if test "x$IEEE" != x ; then              if test "x$IEEE" != x ; then
329                  command="$command -ieee"                  command="$command -ieee"
330              fi              fi
331                if test "x$GSL" = xt ; then
332                    command="$command -gsl"
333                fi
334              if test "x$MPI" = xt ; then              if test "x$MPI" = xt ; then
335                  command="$command -mpi"                  command="$command -mpi"
336              fi              fi
337                if test "x$MULTI_THREAD" = xt ; then
338                #- run multi-threaded using OpenMP:
339                    command="$command -omp"
340                fi
341                if test "x$TS" = xt ; then
342                    command="$command -ts"
343                fi
344                if test "x$PAPIS" = xt ; then
345                    command="$command -papis"
346                else
347                if test "x$PCLS" = xt ; then
348                    command="$command -pcls"
349                fi
350                fi
351              printf 'genmake ... ' 1>&2              printf 'genmake ... ' 1>&2
352              $command > make.log 2>&1              # $command > make.log 2>&1
353                eval $command > make.log 2>&1
354              RETVAL=$?              RETVAL=$?
355              #  Reduce the size of the testing emails!              #  Reduce the size of the testing emails!
356              head -100 Makefile > $CDIR/Makefile_head              head -100 Makefile > $CDIR/Makefile_head
# Line 324  makeclean() Line 370  makeclean()
370  {  {
371      # makeclean directory      # makeclean directory
372      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
373          echo "make CLEAN skipped!"          echo "make Clean skipped!"
374      else      else
375          (          (
376              cd $1;              cd $1;
377              if test -e output.txt ; then              #if test -e $OUTPUTFILE ; then rm -f $OUTPUTFILE ; fi
                 rm -f output.txt  
             fi  
             printf 'make CLEAN ... ' 2>&1  
378              if test -r Makefile ; then              if test -r Makefile ; then
379                  $MAKE CLEAN >> make.log 2>&1                  printf 'clean build-dir: make Clean ... ' 2>&1
380                    $MAKE Clean >> make.log 2>&1
381                  RETVAL=$?                  RETVAL=$?
382                  if test "x$RETVAL" != x0 ; then                  if test "x$RETVAL" != x0 ; then
383                      tail make.log                      tail make.log
384                      echo "makeclean: \"make CLEAN\" failed" 1>&2                      echo "makeclean: \"make Clean\" failed" 1>&2
385                      cp make.log $CDIR"/make.log"                      cp make.log $CDIR"/make.log"
386                      return 1                      return 1
387                  fi                  fi
388                    echo successful 1>&2
389                else
390                    echo ''
391              fi              fi
             echo successful 1>&2  
392              exit 0              exit 0
393          )          )
394      fi      fi
395  }  }
396    
397  postclean()  run_clean()
398  {  {
399      # postclean directory      # run_clean directory
400      if test "x$POSTCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
401            echo "run_clean skipped!"
402        else
403          (          (
404              cd $1;              cd $1;
405              if test -r Makefile ; then              printf 'clean run-dir ... ' 2>&1
406                  $MAKE CLEAN >> /dev/null 2>&1              # part of what is done after "make clean" when doing "make CLEAN"
407              fi              find . -name "*.meta" -exec rm {} \;
408                find . -name "*.data" -exec rm {} \;
409                find . -name "fort.*" -exec rm {} \;
410                find . -type l -exec rm {} \;
411                rm -f $EXECUTABLE *.txt STD* *diagnostics.log datetime
412                rm -rf mnc_test_*
413                rm -f *_MIT_CE_000.opt0000 costfunction*0000
414                echo successful 1>&2
415              exit 0              exit 0
416          )          )
417      fi      fi
# Line 392  makemodel() Line 447  makemodel()
447          cd $1;          cd $1;
448          if test -r Makefile ; then          if test -r Makefile ; then
449              printf 'make ... ' 1>&2              printf 'make ... ' 1>&2
450              if test "x$ADM" = x ; then              if test "x$ADM" = xt ; then
451                    $MAKE adall >> make.log 2>&1
452                elif test "x$OADM" = xt ; then
453                    $MAKE adAll >> make.log 2>&1
454                else
455                  if test "x$JOBS" = x ; then                  if test "x$JOBS" = x ; then
456                      $MAKE >> make.log 2>&1                      $MAKE >> make.log 2>&1
457                  else                  else
458                      $MAKE -j $JOBS >> make.log 2>&1                      $MAKE -j $JOBS >> make.log 2>&1
459                  fi                  fi
             else  
                 $MAKE adall >> make.log 2>&1  
460              fi              fi
461              RETVAL=$?              RETVAL=$?
462              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
# Line 426  symlink_mpifiles() Line 483  symlink_mpifiles()
483      CODE_DIR=$dir/$code_dir      CODE_DIR=$dir/$code_dir
484            
485      # These are files that should replace their counter-part when using -mpi      # These are files that should replace their counter-part when using -mpi
486      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi")`      MPI_FILES=`(cd $CODE_DIR; find . -name "*_mpi" -print)`
487    
488      #  Is this an MPI run?      #  Is this an MPI run?
489      if test "x$MPI" = xt ; then      if test "x$MPI" = xt ; then
# Line 464  symlink_mpifiles() Line 521  symlink_mpifiles()
521    
522  linkdata()  linkdata()
523  {  {
524      # linkdata flag      # linkdata run_dir input_dir_1 input_dir_2 ...
525      #      #
526      # symbolically link data files to run directory      # symbolically link data files to run directory
527      if test "x$1" = x1 ; then      if test -d $1 ; then
528          (          (
529              cd $2              cd $1 ; shift
530              if test "x$ADM" = x ; then              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
531                  files=`( cd ../input ; ls -1 | grep -v CVS )`              for xx in $inpMPI ; do
532                  for i in $files ; do                if test -r "../"$1"/"$xx ; then
533                      if test ! -d "../input/"$i -a ! -f $i ; then                  # found 1 _mpi sfx file in 1rst input dir and it is readable
534                          ln -sf "../input/"$i $i                  yy=`echo $xx | sed 's:\.mpi$::'`
535                    if test "x$MPI" = "xt" ; then
536                    # mpi test: remove symbolic link & link _mpi sfx file
537                        if test -h $yy ; then rm -f $yy ; fi
538                        if test ! -r $yy ; then
539                            ln -sf "../"$1"/"$xx $yy ;
540                            printf "$xx " 1>&2
541                      fi                      fi
542                  done                  else
543              else                  # not mpi test: remove symbolic link
544                  files=`( cd ../input ; ls -1 *.bin | grep -v CVS )`                      if test -h $yy ; then rm -f $yy ; fi
545                  for i in $files ; do                  fi
546                      if test ! -d "../input/"$i ; then                fi
547                          ln -sf "../input/"$i $i              done
548                      fi              if test -r "../"$1"/eedata.mth" ; then
549                  done              # found eedata.mth in 1rst input dir and it is readable
550                  files=`( cd ../input_ad ; ls -1 | grep -v CVS )`                  if test "x$MULTI_THREAD" = "xt" ; then
551                  for i in $files ; do                  # multi-threaded test: remove symbolic link & link eedata.mth
552                      if test ! -d "../input_ad/"$i ; then                      if test -h eedata ; then rm -f eedata ; fi
553                          ln -sf "../input_ad/"$i $i                      if test ! -r eedata ; then
554                            ln -sf "../"$1"/eedata.mth" eedata ;
555                            printf 'eedata.mth ' 1>&2
556                      fi                      fi
557                  done                  else
558                    # not multi-threaded test: remove eedata symbolic link
559                        if test -h eedata ; then rm -f eedata ; fi
560                    fi
561              fi              fi
562                prevDir='NONE'
563                for ldir in $* ; do
564                    if test -d "../"$ldir -a $ldir != $prevDir ; then
565                        printf 'ldir='${ldir} 1>&2
566                        files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
567                        for i in $files ; do
568                            if test ! -d "../"$ldir/$i ; then
569                                if test ! -r $i  ; then
570                                    printf ' '$i 1>&2
571                                    ln -sf "../"$ldir"/"$i $i
572                                fi
573                            fi
574                        done
575                        if test -x "../"$ldir"/"prepare_run ; then
576                            "../"$ldir"/"prepare_run
577                        fi
578                        printf ' ; ' 1>&2
579                    fi
580                    prevDir=$ldir
581                done
582          )          )
583      fi      fi
584  }  }
# Line 503  runmodel() Line 591  runmodel()
591      #  (where "$COMMAND" is relative to "directory")      #  (where "$COMMAND" is relative to "directory")
592      (      (
593          cd $1          cd $1
594          printf 'runmodel ... ' 1>&2          printf 'runmodel in %s ...' $1 1>&2
595          # make output.txt          # make output.txt
596          echo          echo
597          rm -f run.log          if test -L $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
598          # echo "COMMAND='$COMMAND'"              diff -q $EXECUTABLE "../"$builddir"/"$EXECUTABLE > /dev/null 2>&1
599          # echo "pwd='"`pwd`"'"              outD=$? ; if test $outD != 0 ; then rm -f $EXECUTABLE ; fi
600          ( eval $COMMAND ) > run.log 2>&1          fi
601          RETVAL=$?          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
602          if test "x$RETVAL" = x0 ; then              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
603              tail run.log              ln -sf "../"$builddir"/"$EXECUTABLE .
604            fi
605            if test ! -x $EXECUTABLE ; then
606                    rm -f $RUNLOG ; touch $RUNLOG
607                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
608                    echo " no executable:" $EXECUTABLE >> $RUNLOG
609                    RETVAL=8
610                    ENDVAL=-1
611            else
612                if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
613                  # output do not exist or is older than executable:
614                    rm -f $RUNLOG ; touch $RUNLOG
615                    if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
616                    ( eval $COMMAND ) >> $RUNLOG 2>&1
617                    RETVAL=$?
618                else
619                    RETVAL=0
620                    if test -f $RUNLOG ; then
621                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
622                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
623                    else
624                        touch $RUNLOG
625                        if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
626                        echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
627                        echo " no previous $RUNLOG: assume NORMAL END" >> $RUNLOG 2>&1
628                    fi
629                fi
630                ENDVAL=`cat $RUNLOG | grep -v 'ABNORMAL END' | grep -c 'NORMAL END'`
631            fi
632            rm -f run.log_tmp
633            #if test "x$RETVAL" = x0 ; then
634            if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
635                tail $RUNLOG
636              echo successful 1>&2              echo successful 1>&2
637              # === Reduce the size of the testing emails!              # === Reduce the size of the testing emails!
638              # if test "x$ADM" = x ; then              #cp $OUTPUTFILE $CDIR"/"$OUTPUTFILE
             #   cp output.txt $CDIR"/output.txt"  
             # else  
             #   cp output.txt_adm $CDIR"/output.txt_adm"  
             # fi  
639              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
640              return 0              return 0
641          else          else
642              tail run.log              tail $RUNLOG
643              echo failed 1>&2              echo failed '(run:' $RETVAL ' end:' $ENDVAL ')' 1>&2
644              cp run.log $CDIR"/run.log"              cp $RUNLOG $CDIR"/"$RUNLOG
645              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi              if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
646              return 1              return 1
647          fi          fi
# Line 536  createcodelet() Line 652  createcodelet()
652  {  {
653      # create codelet for comparing model output      # create codelet for comparing model output
654    
655      printf "creating the comparison code...  "      printf "creating the comparison code (using CC=$CC)...  "
656      cat > tmp_cmpnum.c <<EOF      cat > tr_cmpnum.c <<EOF
657  #include <stdio.h>  #include <stdio.h>
658  #include <math.h>  #include <math.h>
659  int main( int argc, char** argv )  {  int main( int argc, char** argv )  {
660    int linnum,best,lncnt;    int linnum,cmplin,best,lncnt;
661    double a,b,abave,relerr;    double a,b,abave,relerr;
662    best = -22;    best = -22;
663    lncnt = 0;    lncnt = 0;
664    while( 1 & (lncnt+=1) < 999 )  {    while( 1 & ( (lncnt+=1) < 999 ) )  {
665      scanf("%d", &linnum);      scanf("%d", &linnum);
666      if (linnum == -1)  break;      if (linnum == -1)  break;
667      scanf("%lf", &a);  scanf("%lf", &b);      scanf("%lf", &a);  scanf("%lf", &b);
668      abave = 0.5*(fabs(a)+fabs(b));      abave = 0.5*(fabs(a)+fabs(b));
669      if (abave > 0.0) {      if ( abave == abave ) {
670        relerr=fabs(a-b)/abave;        if (abave > 0.0) {
671        if (relerr > 0.0) { linnum = (int)rint(log10(relerr)); }          relerr=fabs(a-b)/abave;
672        else { linnum = -16 ; }          if (relerr > 0.0) { cmplin = (int)rint(log10(relerr)); }
673        best = (best > linnum) ? best : linnum;          else { cmplin = -16 ; }
674      }          best = (best > cmplin) ? best : cmplin; }
675          else { cmplin = -22 ; }
676       /* printf("%d ; %lf ; %lf\n",cmplin,a,b); */
677          }
678       else {
679       /* printf("%lf ; %lf ; %lf\n",abave,a,b); */
680          break; }
681    }    }
682    if (lncnt == 999) best=-29;    if (lncnt == 999) best=-29;
683      if (linnum != -1) best=-99;
684    printf("%d\n", -best);    printf("%d\n", -best);
685    return 0;    return 0;
686  }  }
687  EOF  EOF
688      $CC -o tmp_cmpnum tmp_cmpnum.c -lm      $CC -o tr_cmpnum tr_cmpnum.c -lm
689    
690      if [ -x ./tmp_cmpnum ]; then      if [ -x ./tr_cmpnum ]; then
691          echo "OK"          echo "OK"
692          return 0          return 0
693      else      else
# Line 582  formatresults() Line 705  formatresults()
705      nm=$1      nm=$1
706      printf '%s %s %s %s' $2 $3 $4 $5      printf '%s %s %s %s' $2 $3 $4 $5
707      shift; shift; shift; shift; shift;      shift; shift; shift; shift; shift;
708      printf '%3s' $@      listPrt=$@
709        listRes=`echo $listPrt | sed 's/>//' | sed 's/<//'`
710        xx=`echo $listPrt | sed 's/.*>//' | sed 's/<.*//' | awk '{print $1}'`
711        printf '%3s' $listPrt
712    #   line below does not work on hp-ux_ia64 : do those substitutions later on
713    #   printf '%3s' $listPrt | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</'
714            
715      if [ $1 = '--' ]; then      if [ $xx = '..' ]; then
716            printf ' N/O '
717        elif [ $xx = '--' ]; then
718            printf ' N/O '
719        elif [ $xx = 99 ]; then
720          printf ' N/O '          printf ' N/O '
721      else      else
722          if [ $1 -gt 12 ]; then          if [ $xx -ge $MATCH_CRIT ]; then
723              printf ' pass'              printf ' pass'
724          else          else
725              printf ' FAIL'              printf ' FAIL'
# Line 598  formatresults() Line 730  formatresults()
730            
731  }  }
732    
733  show_help()  scandirs()
734  {  {
735      cat - << EOF      if [ $# -eq 1 ]; then
736  $0 [-help] [-quick] [-verbose] dir1 [dir2] [...]          for arg in * ; do
737                test -f $arg/$1 && echo $arg
738   -help|-h      Show this help message          done
739   -quiet     Reduce the amount of output      else
740   -verbose   Produce copious amounts of output          echo $*
741   -debug     Produce even more output which will mean nothing to most      fi
  -force     Do "make CLEAN" before compiling. This forces a complete rebuild.  
  -clean     Do "make CLEAN" after compiling and testing.  
  -cleanup   Aggresively removes all model output, executables and object files  
             and then exits. Use with care.  
   
 Normal usage:  
  $0 *       Configure, compile, run and analyze in all experiment directories  
 EOF  
742  }  }
743    
744  scandirs()  
745    check_eedata()
746  {  {
747      if [ $# -eq 0 ]; then      # check_eedata size.h eedata
748          for arg in * ; do      if [ $# -eq 2 ] ; then
749              test -d $arg/input && echo $arg        if test -f $1 -a -f $2 ; then
750          done        sx=`grep "^     & *nSx *=" $1 | sed "s/^     & *nSx *=//" | sed 's/, *$//'`
751          nx=`grep "^ *nTx *=" $2 | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
752          if test "x$nx" = x ; then
753            rx=10
754          else
755            rx=`expr $sx % $nx`
756          fi
757          sy=`grep "^     & *nSy *=" $1 | sed "s/^     & *nSy *=//" | sed 's/, *$//'`
758          ny=`grep "^ *nTy *=" $2 | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
759          if test "x$ny" = x ; then
760            ry=20
761          else
762            ry=`expr $sy % $ny`
763          fi
764          echo `expr $rx + $ry`
765        else
766          echo '-1'
767          fi
768      else      else
769          echo $*        echo '-2'
770      fi      fi
 }  
771    
772    }
773    
774  ###############################################################################  ###############################################################################
775    
# Line 636  scandirs() Line 778  scandirs()
778  debug=0  debug=0
779  verbose=1  verbose=1
780  clean=0  clean=0
 expts=''  
 # ieee=1  
781    
782  IEEE=true  IEEE=true
783  if test "x$MITGCM_IEEE" != x ; then  if test "x$MITGCM_IEEE" != x ; then
784      IEEE=$MITGCM_IEEE      IEEE=$MITGCM_IEEE
785  fi  fi
786    GSL=f
787    
788  CLEANUP=f  CLEANUP=f
789  QUICK=f  QUICK=f
# Line 656  BASH= Line 796  BASH=
796  OPTFILE=NONE  OPTFILE=NONE
797  ADDRESSES=  ADDRESSES=
798  TESTDIRS=  TESTDIRS=
799    SKIPDIRS=
800  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
801  HAVE_MPACK=  HAVE_MPACK=
802  MPACK="$MPACKDIR/mpack"  MPACK=
803  COMMAND=  COMMAND=
804  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
805      MAKE=make      MAKE=make
# Line 668  if test "x$CC" = x ; then Line 809  if test "x$CC" = x ; then
809  fi  fi
810  JOBS=  JOBS=
811  MPI=f  MPI=f
812    MULTI_THREAD=f
813    OUTDIR=
814  DELDIR=  DELDIR=
815    
816  ADM=  ADM=
817    OADM=
818    
819  # Additional monitor types  # list of pTracers to check for monitor output
820  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
821    
822    MATCH_CRIT=13
823    
824  printf "parsing options...  "  printf "parsing options...  "
825    
826  ac_prev=  ac_prev=
# Line 703  for ac_option ; do Line 849  for ac_option ; do
849              ac_prev=ADDRESSES ;;              ac_prev=ADDRESSES ;;
850          -addr=* | --addr=*)          -addr=* | --addr=*)
851              ADDRESSES=$ac_optarg ;;              ADDRESSES=$ac_optarg ;;
852            -mpackdir | --mpackdir | -mpd | --mpd)
853                ac_prev=MPACKDIR ;;
854            -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*)
855                MPACKDIR=$ac_optarg ;;
856    
857          -tdir | --tdir | -t | --t)          -tdir | --tdir | -t | --t)
858              ac_prev=TESTDIRS ;;              ac_prev=TESTDIRS ;;
859          -tdir=* | --tdir=*)          -tdir=* | --tdir=*)
860              TESTDIRS=$ac_optarg ;;              TESTDIRS=$ac_optarg ;;
861    
862            -skipdir | --skipdir | -skd | --skd)
863                ac_prev=SKIPDIRS ;;
864            -skipdir=* | --skipdir=*)
865                SKIPDIRS=$ac_optarg ;;
866    
867          -bash | --bash | -b | --b)          -bash | --bash | -b | --b)
868              ac_prev=BASH ;;              ac_prev=BASH ;;
869          -bash=* | --bash=*)          -bash=* | --bash=*)
# Line 724  for ac_option ; do Line 879  for ac_option ; do
879          -make=* | --make=*)          -make=* | --make=*)
880              MAKE=$ac_optarg ;;              MAKE=$ac_optarg ;;
881    
882            -odir | --odir)
883                ac_prev=OUTDIR ;;
884            -odir=* | --odir=*)
885                OUTDIR=$ac_optarg ;;
886    
887          -ptracers | --ptracers | -ptr | --ptr)          -ptracers | --ptracers | -ptr | --ptr)
888              ac_prev=PTRACERS_NUM ;;              ac_prev=PTRACERS_NUM ;;
889          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)          -ptracers=* | --ptracers=* | -ptr=* | --ptr=*)
890              PTRACERS_NUM=$ac_optarg ;;              PTRACERS_NUM=$ac_optarg ;;
891    
892            -match | --match ) ac_prev=MATCH_CRIT ;;
893            -match=* | --match=* ) MATCH_CRIT=$ac_optarg ;;
894    
895          -j) ac_prev=JOBS ;;          -j) ac_prev=JOBS ;;
896          -j=*) JOBS=$ac_optarg ;;          -j=*) JOBS=$ac_optarg ;;
897    
898          -clean | --clean)          -clean | --clean)
899              CLEANUP=t ;;              CLEANUP=t ; DELDIR=t ;;
900    
901          -quick | --quick | -q | --q)          -quick | --quick | -q | --q)
902              QUICK=t ;;              QUICK=t ;;
# Line 749  for ac_option ; do Line 912  for ac_option ; do
912    
913          -mpi) MPI=t ;;          -mpi) MPI=t ;;
914    
915            -mth) MULTI_THREAD=t ;;
916    
917          -adm | -ad) ADM=t ;;          -adm | -ad) ADM=t ;;
918    
919            -oad) OADM=t; NODEPEND=t ;;
920    
921          -ieee) IEEE=true ;;          -ieee) IEEE=true ;;
922          -noieee) IEEE= ;;          -noieee) IEEE= ;;
923            -gsl) GSL=t ;;
924    
925          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
926          -debug) debug=1 ;;          -debug) debug=1 ;;
# Line 760  for ac_option ; do Line 928  for ac_option ; do
928    
929          -deldir | -dd) DELDIR=t ;;          -deldir | -dd) DELDIR=t ;;
930    
931            -ts) TS=t;;
932    
933            -papis) PAPIS=t;;
934    
935            -pcls) PCL=t;;
936    
937          -*)          -*)
938              echo "Error: unrecognized option: "$ac_option              echo "Error: unrecognized option: "$ac_option
939              usage              usage
# Line 780  if test "x$QUICK" = xt ; then Line 954  if test "x$QUICK" = xt ; then
954      NODEPEND=t      NODEPEND=t
955  fi  fi
956    
957    #- setting for forward or ADM testing
958    if test "x$ADM" = xt ; then
959        code_dir=code_ad
960        inputdir=input_ad
961        ref_outp="output_adm.txt"
962        EXECUTABLE="mitgcmuv_ad"
963    elif test "x$OADM" = xt ; then
964        code_dir=code_oad
965        inputdir=input_oad
966        ref_outp="output_oadm.txt"
967        EXECUTABLE="mitgcmuv_ad"
968    else
969        code_dir=code
970        inputdir=input
971        ref_outp="output.txt"
972        EXECUTABLE="mitgcmuv"
973    fi
974    
975  if test "x$TESTDIRS" = x ; then  if test "x$TESTDIRS" = x ; then
976      TESTDIRS=`scandirs`      LIST=`scandirs results/$ref_outp`
977    else
978        #- expand group of experiments:
979        LIST=" "
980        for xx in $TESTDIRS
981        do
982          case $xx in
983            'basic') LIST=${LIST}" aim.5l_cs hs94.128x64x5 ideal_2D_oce"
984                     LIST=${LIST}" lab_sea tutorial_baroclinic_gyre"
985                     LIST=${LIST}" tutorial_global_oce_latlon tutorial_plume_on_slope"
986                    ;;
987            'tutorials')
988                     LIST=${LIST}" "`ls | grep 'tutorial_'` ;;
989            *)       LIST=${LIST}" "$xx ;;
990          esac
991        done
992  fi  fi
993    #echo 'LIST='${LIST}'<'
994    #- skip dirs, remove duplicate and non-directory:
995    TESTDIRS=" "
996    count=0
997    for xx in $LIST
998    do
999        yy=`echo $SKIPDIRS | grep -c $xx`
1000        if test $yy = 0 ; then
1001            if test -d $xx ; then
1002                yy=`echo $TESTDIRS | grep -c $xx`
1003                if test $yy = 0 ; then TESTDIRS=${TESTDIRS}" "$xx ; fi
1004            else count=1 ;
1005                echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1006            fi
1007        else
1008            if test $count = 1 ; then echo -n ", \"$xx\""
1009            else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1010            fi
1011        fi
1012    done
1013    if test $count = 1 ; then echo "" ; echo -n " ... " ; fi
1014    #echo 'TESTDIRS='${TESTDIRS}'<'
1015    
1016  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then  if test "x$OPTFILE" = xNONE -a "x$MITGCM_OF" != x ; then
1017      OPTFILE=$MITGCM_OF      OPTFILE=$MITGCM_OF
1018  fi  fi
1019    
1020  if test "x$ADM" = xt -a "x$COMMAND" = x ; then  RUNLOG="run.log"
1021      COMMAND="./mitgcmuv_ad > output.txt_adm 2>&1"  OUTPUTFILE=$ref_outp
 fi  
   
1022  if test "x$COMMAND" = x ; then  if test "x$COMMAND" = x ; then
1023      COMMAND="$MAKE output.txt"      COMMAND="./$EXECUTABLE > $OUTPUTFILE"
1024    fi
1025    if test "x$MPI" = xt ; then
1026        OUTPUTFILE="STDOUT.0000"
1027  fi  fi
1028    
1029  echo "OK"  echo "OK (COMMAND= $COMMAND )"
1030    
1031    # set the Default List of output variables to be checked:
1032    #  (use default or load experiment-specific list from file "tr_checklist")
1033    # content : 1rst = main variable used to decide if it pass or FAIL
1034    #         others = number of matching digits to be printed in summary.txt
1035    if test "x$ADM" = x -a "x$OADM" = x; then
1036        DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1037        EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1038        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1039        ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1040        EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
1041    else
1042        DEF_CHECK_LIST='Grad Cost Grad'
1043        EMPTY_RESULTS='.. ..'
1044        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1045    fi
1046    
1047  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1048  createcodelet  createcodelet
1049    
1050  #  build the mpack utility  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1051  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x ; then
1052      echo "skipping mpack build"      echo "skipping mpack build"
1053  else  else
1054      build_mpack      build_mpack
1055  fi  fi
1056    
1057  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1058    CMDLINE=$0
1059    for xx in "$@" ; do nw=`echo $xx | wc -w`
1060        if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"
1061                            else CMDLINE="$CMDLINE '$xx'" ; fi
1062    done
1063    #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1064  MACH=`hostname`  MACH=`hostname`
1065  UNAMEA=`uname -a`  UNAMEA=`uname -a`
1066  DATE=`date +%Y%m%d`  DATE=`date +%Y%m%d`
1067  BASE="tr_"$MACH"_"$DATE"_"  BASE="tr_"$MACH"_"$DATE"_"
1068    if test "x$OUTDIR" != x ; then
1069        BASE="tr_"$OUTDIR"_"$DATE"_"
1070    else
1071        short_name=`hostname | sed 's/\..*$//'`
1072        BASE="tr_"$short_name"_"$DATE"_"
1073    fi
1074  DNUM=0  DNUM=0
1075  DRESULTS="$BASE$DNUM"  DRESULTS="$BASE$DNUM"
1076  while test -e $DRESULTS ; do  while test -e $DRESULTS ; do
# Line 826  if test "x$RETVAL" != x0 ; then Line 1084  if test "x$RETVAL" != x0 ; then
1084      exit 1      exit 1
1085  fi  fi
1086  SUMMARY="$DRESULTS/summary.txt"  SUMMARY="$DRESULTS/summary.txt"
 printf "Start time:  " >> $SUMMARY  
1087  start_date=`date`  start_date=`date`
1088  echo $start_date > $SUMMARY  echo $start_date > $SUMMARY
1089    echo 'run:' $CMDLINE >> $SUMMARY
1090    echo 'on :' $UNAMEA  >> $SUMMARY
1091    
1092  of_path=  of_path=
1093  if test "x$OPTFILE" != xNONE ; then  if test "x$OPTFILE" != xNONE ; then
# Line 857  else Line 1116  else
1116  fi  fi
1117  echo  echo
1118  echo >> $SUMMARY  echo >> $SUMMARY
1119  if test "x$ADM" = x ; then  if test "x$ADM" = x -a "x$OADM" = x; then
1120      line_0="            ----T-----  ----S-----  ----U-----  ----V-----"      if [ $MATCH_CRIT -lt 10 ] ;
1121        then line_0="default  "$MATCH_CRIT ;
1122        else line_0="default "$MATCH_CRIT ; fi
1123           line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1124    #   line_0="            ----T-----  ----S-----  ----U-----  ----V-----"
1125      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1126      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1127      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1128      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1129      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
         #  tst=`eval 'echo $HAVE_PTR0'$ii`  
         #  if test "x$tst" = xt ; then  
1130          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
1131          line_1="$line_1        m  s"          line_1="$line_1        m  s"
1132          line_2="$line_2  m  m  e  ."          line_2="$line_2  m  m  e  ."
1133          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1134          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
         #  fi  
1135      done      done
1136      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1137      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
# Line 882  if test "x$ADM" = x ; then Line 1142  if test "x$ADM" = x ; then
1142  else  else
1143      echo "ADJOINT=true" >> $SUMMARY      echo "ADJOINT=true" >> $SUMMARY
1144      echo >> $SUMMARY      echo >> $SUMMARY
1145        if [ $MATCH_CRIT -lt 10 ] ;
1146        then line_0="default     "$MATCH_CRIT ;
1147        else line_0="default    "$MATCH_CRIT ; fi
1148        echo "$line_0" | tee -a $SUMMARY
1149      cat << EOF | tee -a $SUMMARY      cat << EOF | tee -a $SUMMARY
1150  G D M    C  G  G D M    C  G
1151  E p a R  o  r  E p a R  o  r
# Line 894  fi Line 1158  fi
1158  #  ...and each test directory...  #  ...and each test directory...
1159  for dir in $TESTDIRS ; do  for dir in $TESTDIRS ; do
1160            
1161        # set builddir & rundir:
1162        builddir="build"
1163        if test ! -d $dir/$builddir ; then mkdir $dir/$builddir ; fi
1164        rundir="run"
1165        if test ! -d $dir/$rundir ; then
1166            rundir=$builddir
1167        fi
1168        CODE_DIR=$dir/$code_dir
1169        BUILD_DIR=$dir/$builddir
1170    
1171      #  Cleanup only!      #  Cleanup only!
1172      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1173          if test -r $dir/build/Makefile ; then          echo -n '  --- dir:' $BUILD_DIR ': '
1174              ( cd $dir/build ; make CLEAN )          makeclean $BUILD_DIR
1175            if test -d $dir/$rundir/CVS ; then
1176                echo -n '  --- dir:' $dir/$rundir ': '
1177                run_clean $dir/$rundir
1178          fi          fi
1179          if test -r $dir/input/Makefile ; then          trdir=`( cd $dir ; find . -type d -name "tr_run.*" -print | sed 's/^.\///')`
1180              ( cd $dir/input ; make CLEAN )          ttd=`echo $trdir | wc -w`
1181            if test $ttd != 0 ; then
1182                echo '  --- rm dir:' $trdir
1183                ( cd $dir ; rm -rf $trdir )
1184          fi          fi
         (  
             cd $dir  
             rm -rf tr_run.*  
         )  
1185          continue          continue
1186      fi      fi
1187    
1188      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1189      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1190      fout=      fout=$dir"/results/"$ref_outp
     if test "x$ADM" = x ; then  
         fout=$dir"/results/output.txt"  
     else  
         fout=$dir"/results_ad/output.txt_adm"  
     fi  
1191      if test ! -r $fout ; then      if test ! -r $fout ; then
1192          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1193          continue          continue
1194      fi      fi
     if test "x$ADM" = x ; then  
         check_for_add_mon_output  $fout  
     fi  
1195    
1196      # Check for additional types of monitor output      # Check for specific files for particular type of run
1197    
1198      builddir="input"      if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then
1199      rundir="input"          echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"
1200      use_seperate_build=0          continue
     if test -d $dir/build -a -r $dir/build ; then  
         builddir="build"  
         rundir="build"  
         use_seperate_build=1  
         linkdata $use_seperate_build $dir/$rundir  
1201      fi      fi
1202            if test ! -r $dir"/input/eedata.mth" -a "x$MULTI_THREAD" = "xt" ; then
1203            echo "can't find \"$dir/input/eedata.mth\" -- skipping $dir"
1204            continue
1205        fi
1206        if test "x$MPI" = "xt" -a "x$MULTI_THREAD" = "xt" ; then
1207          retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/input/eedata.mth"`
1208          if test $retv != 0 ; then
1209            echo "input/eedata.mth tiling misfit -- skipping $dir"
1210            continue
1211          fi
1212        fi
1213    
1214      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1215      extra_runs=      extra_runs=
1216      if test "x$ADM" = x -a "x$use_seperate_build" = x1 ; then      ex_run_dirs=`( cd $dir ; echo $inputdir.* )`
1217          ex_run_dirs=`( cd $dir ; echo input.* )`      #echo "ex_run_dirs='$ex_run_dirs'"
1218          echo "ex_run_dirs='$ex_run_dirs'"      for exd in $ex_run_dirs ; do
1219          for exd in $ex_run_dirs ; do          name=`echo $exd | sed -e "s/$inputdir\.//"`
1220              name=`echo $exd | sed -e 's/input.//g'`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1221              outf="$dir/results/output.txt.$name"          outf="$dir/results/$refExOut"
1222              if test -f $outf -a -r $outf ; then          if test -f $outf -a -r $outf ; then
1223              if test "x$MULTI_THREAD" = "xt" ; then
1224                if test -r $dir"/"$exd"/eedata.mth" ; then
1225                  if test "x$MPI" = "xt" ; then
1226                    retv=`check_eedata $CODE_DIR"/SIZE.h_mpi" $dir"/"$exd"/eedata.mth"`
1227                    if test $retv = 0 ; then
1228                        extra_runs="$extra_runs $name"
1229                    else
1230                        echo $exd"/eedata.mth tiling misfit -- skipping $dir"
1231                    fi
1232                  else
1233                  extra_runs="$extra_runs $name"                  extra_runs="$extra_runs $name"
1234                  fi
1235                #else echo $dir"/"$exd"/eedata.mth: not found"
1236              fi              fi
1237          done            else
1238      fi              extra_runs="$extra_runs $name"
1239              fi
1240      if test "x$ADM" = x ; then          fi
1241          code_dir=code      done
         CODE_DIR=$dir/code  
     else  
         code_dir=code_ad  
         CODE_DIR=$dir/code_ad  
     fi  
     BUILD_DIR=$dir/$builddir  
   
     if test ! -r $CODE_DIR"/SIZE.h_mpi" -a "x$MPI" = "xt" ; then  
         echo "can't find \"$CODE_DIR/SIZE.h_mpi\" -- skipping $dir"  
         continue  
     fi  
1242    
1243      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1244      echo      echo
1245      echo "Experiment:  $dir"      if test "x$extra_runs" = "x" ; then
1246           echo "Experiment:  $dir"
1247        else
1248           echo "Experiment:  $dir ; extra_runs=$extra_runs"
1249        fi
1250      echo      echo
1251      unset genmake makedepend make run      unset genmake makedepend make run
1252      results='-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- --'      results=$EMPTY_RESULTS
1253    
1254      #  Create an output dir for each OPTFILE/tdir combination      #  Create an output dir for each OPTFILE/tdir combination
1255      rel_CDIR=$DRESULTS"/"$dir      rel_CDIR=$DRESULTS"/"$dir
# Line 978  for dir in $TESTDIRS ; do Line 1257  for dir in $TESTDIRS ; do
1257      CDIR=`pwd`"/$rel_CDIR"      CDIR=`pwd`"/$rel_CDIR"
1258            
1259      if test "x$CLEANUP" = xt ; then      if test "x$CLEANUP" = xt ; then
1260          makeclean $dir/$builddir          echo '====>>> this is to check that we never go through this part <<< ==='
1261            makeclean $dir/$builddir \
1262                && run_clean $dir/$rundir
1263      else      else
1264          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1265              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1266                && run_clean $dir/$rundir \
1267              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1268              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1269              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1270              && linkdata $use_seperate_build $dir/$rundir \              && linkdata $dir/$rundir $inputdir input \
1271              && runmodel $dir/$rundir && run=Y \              && runmodel $dir/$rundir && run=Y \
1272              && results=`testoutput $dir $rundir`              && results=`testoutput_run $dir $rundir $ref_outp`
1273      fi      fi
1274            
1275      echo      echo
     if test "x$ADM" = x ; then  
1276          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1277          echo          echo
1278          echo "$fres" >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1279          echo "fresults='$fres'" > $CDIR"/summary.txt"          touch $CDIR"/summary.txt"
1280            echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1281          echo "MACH='$MACH'" >> $CDIR"/summary.txt"          echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1282          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"          echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1283          echo "DATE='$DATE'" >> $CDIR"/summary.txt"          echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1284          echo "tdir='$dir'" >> $CDIR"/summary.txt"          echo "tdir='$dir'" >> $CDIR"/summary.txt"
1285            if test "x$ADM" = xt ; then
1286                head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1287                grep -A3 'Seconds in section "ALL' $dir/$rundir/$OUTPUTFILE \
1288                                    >> $CDIR"/summary.txt"
1289            fi
1290    
1291          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1292                unset run
1293                results=$EMPTY_RESULTS
1294                #  reference output file
1295                refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1296                #  Create an output dir for each OPTFILE/tdir.ex combination
1297                rel_CDIR=$DRESULTS"/"$dir"."$ex
1298                mkdir $rel_CDIR
1299                CDIR=`pwd`"/$rel_CDIR"
1300              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"              test ! -e "$dir/tr_run.$ex" && mkdir "$dir/tr_run.$ex"
1301              for ldir in input.$ex input ; do              run_clean $dir/tr_run.$ex
1302                  (              linkdata $dir/tr_run.$ex $inputdir.$ex $inputdir input
                     cd "$dir/$ldir" > /dev/null 2>&1  
                     ls -1 2>/dev/null \  
                         | sed -e 's|^CVS$||g' | sed -e 's|^output.txt$||g'  
                 ) > tr_exrun_links  
                 (  
                     cd "$dir/tr_run.$ex"  
                     cat ../../tr_exrun_links | while read i ; do  
                         if test ! "x$i" = x ; then  
                             test ! -r $i  &&  ln -s "../"$ldir"/"$i $i  
                         fi  
                     done  
                 )  
                 test -e tr_exrun_links  &&  rm -f tr_exrun_links  
             done  
             ldir=build  
             (  
                 cd "$dir/$ldir" > /dev/null 2>&1  
                 ls -1 Makefile *.[fFhco] mitgcmuv  2>/dev/null \  
                     | sed -e 's|^CVS$||g' | sed -e 's|^output.txt$||g'  
             ) > tr_exrun_links  
             (  
                 cd "$dir/tr_run.$ex"  
                     cat ../../tr_exrun_links | while read i ; do  
                         if test ! "x$i" = x ; then  
                             test ! -r $i  &&  ln -s "../"$ldir"/"$i $i  
                         fi  
                     done  
             )  
             test -e tr_exrun_links  &&  rm -f tr_exrun_links  
1303              runmodel $dir/tr_run.$ex && run=Y \              runmodel $dir/tr_run.$ex && run=Y \
1304                  && results=`testoutput $dir tr_run.$ex "."$ex`              && results=`testoutput_run $dir tr_run.$ex $refExOut`
             fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
1305              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1306              fres="$fres.$ex"              fres="$fres.$ex"
1307              echo              echo
1308              echo "$fres" >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1309              echo "fresults='$fres'" > $CDIR"/summary.txt"              touch $CDIR"/summary.txt"
1310                echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $CDIR"/summary.txt"
1311              echo "MACH='$MACH'" >> $CDIR"/summary.txt"              echo "MACH='$MACH'" >> $CDIR"/summary.txt"
1312              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"              echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"
1313              echo "DATE='$DATE'" >> $CDIR"/summary.txt"              echo "DATE='$DATE'" >> $CDIR"/summary.txt"
1314              echo "tdir='$dir'" >> $CDIR"/summary.txt"              echo "tdir='$dir.$ex'" >> $CDIR"/summary.txt"
1315                if test "x$ADM" = xt ; then
1316                    head -1 $dir/$builddir/taf_ad.log >> $CDIR"/summary.txt"
1317                    grep -A3 'Seconds in section "ALL' $dir/tr_run.$ex/$OUTPUTFILE \
1318                                       >> $CDIR"/summary.txt"
1319                fi
1320                if test "x$POSTCLEAN" = xt ; then
1321                    run_clean $dir/tr_run.$ex
1322                fi
1323          done          done
     else  
         fres=`printf '%s %s %s %s' ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N}`  
         fres=$fres"$results   $dir"  
         echo  
         echo "$fres" >> $SUMMARY  
         echo "fresults='$fres'" > $CDIR"/summary.txt"  
         echo "MACH='$MACH'" >> $CDIR"/summary.txt"  
         echo "UNAMEA='$UNAMEA'" >> $CDIR"/summary.txt"  
         echo "DATE='$DATE'" >> $CDIR"/summary.txt"  
         echo "tdir='$dir'" >> $CDIR"/summary.txt"  
     fi  
1324    
1325      postclean $dir/$builddir      #postclean $dir/$builddir
1326        if test "x$POSTCLEAN" = xt ; then
1327            makeclean $dir/$builddir \
1328                && run_clean $dir/$rundir
1329        fi
1330            
1331      echo "-------------------------------------------------------------------------------"      echo "-------------------------------------------------------------------------------"
1332            
1333  done  done
1334    
1335  printf "Start time:  " >> $SUMMARY  printf "Start time:  " >> $SUMMARY
1336  echo $start_date >> $SUMMARY  echo "$start_date" >> $SUMMARY
1337  printf "End time:    " >> $SUMMARY  printf "End time:    " >> $SUMMARY
1338  date >> $SUMMARY  date >> $SUMMARY
1339    
# Line 1097  else Line 1364  else
1364      fi      fi
1365  fi  fi
1366    
1367  # rm -f tmp_cmpnum.f a.out  rm -f tr_cmpnum.c tr_cmpnum
 rm -f tmp_cmpnum.c tmp_cmpnum  
1368    
1369  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1370      cat $SUMMARY | sed 's/ -- -- -- --//g'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1371      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1372          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1373      fi      fi
1374      cat $SUMMARY | sed 's/ -- -- -- --//g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1375  fi  fi
1376    
1377  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then

Legend:
Removed from v.1.68  
changed lines
  Added in v.1.127

  ViewVC Help
Powered by ViewVC 1.1.22